install_headers.sh 2.8 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192
  1. #!/bin/sh
  2. # Parameters:
  3. # $1 = source dir
  4. # $2 = dst dir
  5. # $top_builddir = well you guessed it
  6. die_if_not_dir()
  7. {
  8. for dir in "$@"; do
  9. test -d "$dir" && continue
  10. echo "Error: '$dir' is not a directory"
  11. exit 1
  12. done
  13. }
  14. # Ensure that created dirs/files have 755/644 perms
  15. umask 022
  16. # Sanity tests
  17. die_if_not_dir "$1"
  18. mkdir -p "$2" 2>/dev/null
  19. die_if_not_dir "$2"
  20. die_if_not_dir "$top_builddir"
  21. if ! test -x "$top_builddir/extra/scripts/unifdef"; then
  22. echo "Error: need '$top_builddir/extra/scripts/unifdef' executable"
  23. exit 1
  24. fi
  25. # Sanitize and copy uclibc headers
  26. (
  27. # We must cd, or else we'll prepend "$1" to filenames!
  28. cd "$1" || exit 1
  29. find ! -name '.' -a ! -path '*/.*'
  30. ) | \
  31. (
  32. IFS=''
  33. while read -r filename; do
  34. filename="${filename#./}"
  35. if test -d "$1/$filename"; then
  36. mkdir -p "$2/$filename" 2>/dev/null
  37. else
  38. "$top_builddir/extra/scripts/unifdef" -UUCLIBC_INTERNAL "$1/$filename" >"$2/$filename" || exit
  39. fi
  40. done
  41. )
  42. # Just copy (no sanitization) some kernel headers.
  43. eval `grep ^KERNEL_HEADERS "$top_builddir/.config"`
  44. if ! test "$KERNEL_HEADERS" \
  45. || ! test -d "$KERNEL_HEADERS/asm" \
  46. || ! test -d "$KERNEL_HEADERS/asm-generic" \
  47. || ! test -d "$KERNEL_HEADERS/linux" \
  48. ; then
  49. echo "Error: '$KERNEL_HEADERS' is not a directory containing kernel headers."
  50. echo "Check KERNEL_HEADERS= in your .config file."
  51. exit 1
  52. fi
  53. # Do the copying only if src and dst dirs are not the same
  54. # Be thorough: do not settle just for textual compare,
  55. # and guard against "pwd" being handled as shell builtin
  56. if test `(cd "$KERNEL_HEADERS"; env pwd)` != `(cd "$2"; env pwd)`; then
  57. # NB: source or target files and directories may be symlinks,
  58. # and for all we know, good reasons.
  59. # We must work correctly in these cases. This includes "do not replace
  60. # target symlink with real directory" rule. So, no rm -rf here please.
  61. mkdir -p "$2/asm" 2>/dev/null
  62. mkdir -p "$2/asm-generic" 2>/dev/null
  63. mkdir -p "$2/linux" 2>/dev/null
  64. # Exists, but is not a dir? That's bad, bail out
  65. die_if_not_dir "$2/asm" "$2/asm-generic" "$2/linux"
  66. # cp -HL creates regular destination files even if sources are symlinks.
  67. # This is intended.
  68. # (NB: you need busybox 1.11.x for this. earlier ones are slightly buggy)
  69. cp -RHL "$KERNEL_HEADERS/asm"/* "$2/asm" || exit 1
  70. cp -RHL "$KERNEL_HEADERS/asm-generic"/* "$2/asm-generic" || exit 1
  71. cp -RHL "$KERNEL_HEADERS/linux"/* "$2/linux" || exit 1
  72. if ! test -f "$2/linux/version.h"; then
  73. echo "Warning: '$KERNEL_HEADERS/linux/version.h' is not found"
  74. echo "in kernel headers directory specified in .config."
  75. echo "Some programs won't like that. Consider fixing it by hand."
  76. fi
  77. fi
  78. # Fix mode/owner bits
  79. cd "$2" || exit 1
  80. chmod -R u=rwX,go=rX . >/dev/null 2>&1
  81. chown -R `id | sed 's/^uid=\([0-9]*\).*gid=\([0-9]*\).*$/\1:\2/'` . >/dev/null 2>&1